Subject: RE: [Simple] -05 MESSAGE and Expires header

From: "Sriram Parameswar" <[email-masked]>
Date: Tue, 16 Jul 2002 10:32:28 -0500

Personally I would not like to use Priority and leave the Expires semantic
as is. 

As justification take this example: if you have several IM sessions in
progress, and the window which logs your session with your significant-other
is buried below a ton of other windows. When a message arrives with a
Priority "Urgent" - 'House on Fire' the application (please note - I said
application nothing to do with protocol) could decide to pop the window to
the top. This would not be possible if we overload Priority.

Regards,

Sriram
__________________________________________
Sriram Parameswar              Phone: 972-685-8540
Interactive Multimedia Server (IMS) Fax: 972-684-3986
Nortel Networks, Richardson USA  Email: [email-masked]

-----Original Message-----
From: Ben Campbell [mailto:[email-masked]]
Sent: Tuesday, July 16, 2002 8:26 AM
To: Vijay K. Gurbani
Cc: Tan Ya-Ching ICM N PG U ID A 1; [email-masked]
Subject: Re: [Simple] -05 MESSAGE and Expires header

Vijay K. Gurbani wrote:
> Tan Ya-Ching ICM N PG U ID A 1 wrote:
> 
>> Vijay,
>>
>> It is stated in RFC 3261 section 20.19 Expires that :
>> "The precise meaning of this (header) is method dependant".
> 
> 
> Agreed.
> 
>> The use of the Expires header in MESSAGE is as it is defined in -05. 
>> It has
>> only one meaning, so there is no overloading.
> 
> 
> That is debatable; good thing about ASCII protocols is that they are
> self describing.  Thus, having a "Priority: Urgent" is far more
> preferable to overloading "Expires: 0" to mean immediate handling.
> "Priority: Urgent" in this case makes it far more easy to figure
> out what is going on.
> 
> - vijay
> 
> 
> 
> 

I do not have strong feelings on this one way or another--either 
approach works for me. I will bow to the will of the majority. Anyone 
else have comments?

_______________________________________________
simple mailing list
[email-masked]
http://mailman.dynamicsoft.com/mailman/listinfo/simple

---

From: "Fred O'Leary" <[email-masked]>
Date: Tue, 16 Jul 2002 09:03:23 -0700

I vote for the 'priority' header. Mixing headers/semantics is a sure-fire
path the iter-op problems. The urgent message doesn't 'expire immediately'
and "Expires: 0" implies something like that. 
-Fred

---

From: Adam Roach <[email-masked]>
Date: Mon, 22 Jul 2002 08:50:37 -0500

> From: [email-masked] [mailto:[email-masked]]
> - When is a message urgent but does not require immediate delivery?

Are you proposing an "Urgency" header, or confusing priority with
urgency? I'll see if I can accurately demonstrate their orthangonality.

High Priority, Low Urgency:
  Note to new residents: failure to file income taxes by April
  15th can lead to substantial penalties.

Low Priority, High Urgency:
  You have 5 minutes to come by and pick up the rest of your lunch
  or I'm going to throw it away.
                             
High Priority, High Urgency:
  There's a tornado coming your way!

Low Priority, Low Urgency:
  Llamas can make four distinct noises: humming, clucking, orgling, and
  a high pitched, rhythmic alarm sound.

/a

---

From: Adam Roach <[email-masked]>
Date: Tue, 23 Jul 2002 20:08:37 -0500

> From: Bobby Sardana [mailto:[email-masked]]
>
> The proposal is simple: (not sure from a complete 
> applicability point of
> view, but here it is)
> 
> a. Expire signifies a unit of time

Agreed.

> b. For methods that have the Expire header, the unit of time 
> determines
> the method validitity.

There's a problem with that approach. For SUBSCRIBE and REGISTER,
the "Expires" header doesn't indicate the period of validity of
the request (which is presumably what you mean by "method validity");
it indicates the period of validity for what is *created* by the
request. The analog for INVITE would be "Session-Expires".

> The only exception here is 0, which can mean
> "expired" or "infinite".

There are actually three problems here. 

1. Historically, "0" has never been treated 
   as a special case in SIP expirations. (More
   on this below).

2. "Expires: 0" does not mean "expired" (that
   would, in theory, be represented by a negative
   number -- but we don't do that); it means that
   expiration occurs in zero seconds (i.e.
   instantaneously). For the purposes of instant
   messages, that's exactly what we want to convey:
   "this mesage expires instantaneously -- so, send
   it on or consider it stale" (where handling of
   stale messages is a matter of local policy).

3. Zero has *never* meant infinity in a SIP
   "Expires" context. The convention for "infinity"
   is to use 4294967295 (2^32-1), which ends up being
   over 136 years -- long enough to mean "infinity" for
   the purposes of a computer protocol.

/a